//ok! make a generic attiny program for clam!

//sample thermistor-10k ohm voltage divider on PB3/ADC3
//sample battery voltage on PB4/ADC2
//control blue led on PB2
//control green led on PB1
//control yellow led on PB0
//red led is connected to vcc
//white led is connected to vbatt

//lets do single conversion for the adc
//no interrupts for now

//later, do free running conversion with interrupts

//when measuring battery voltage, use 2.56v internal reference
//when measuring thermistor, use VCC as AREF


#define F_CPU 8000000

#include <stdint.h>
#include <avr/io.h>

uint16_t temperature = 0; 
uint16_t voltage = 0;
uint16_t junk = 0;


void main() {

  //change this to use either 2.56v or VCC as AREF
  //ADMUX = (1<<REFS0);

  // ADC Enable (1<<ADEN)
  // ADC Prescaler = 64 (8,000,000Hz / 64 = 125000Hz) (1<<ADPS2)|(1<<ADPS1)
  ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);
 
  //Set output pins & initial levels
  DDRB |= (1 << DDB4)|(1 << DDB2)|(1 << DDB1)|(1 << DDB0); //sets pins as outputs for leds
  PORTB |= (1 << PORTB4)|(1 << PORTB2)|(1 << PORTB1)|(1 << PORTB0); //sets leds off
       


      
  while(1) {
    /*
    // i need to make a voltage divider that sets battery 3.7v to 1.25v, so ADC reading is 500
    //read battery voltage first
    //set AREF to 2.56v in ADMUX
    ADMUX |= (1<<REFS2)|(1<<REFS1);
    ADMUX &= ~(1<<REFS0);
    //set channel to ADC2/PB4 (MUX[0010])
    ADMUX = (ADMUX & 0xF0)|0b10;
    //discard first ADC reading
    //start single conversion
    ADCSRA |= (1<<ADSC);
    //wait for conversion
    while(ADCSRA & (1<<ADSC));
    junk = ADC;
    //use second ADC reading
    //start single conversion
    ADCSRA |= (1<<ADSC);
    //wait for conversion
    while(ADCSRA & (1<<ADSC));
    //set ADC reading to voltage
    voltage = ADC;//(ADCH << 8)|(ADCL);

    //if battery voltage is below 3.7v (what value is that?), then turn off green LED and turn on yellow LED
    //else turn on green LED and turn off yellow LED
    
    if (voltage > 500) {
      PORTB |= (1<<PORTB1);
      PORTB = (PORTB & 0b11111110);
    }
    else {
      PORTB = (PORTB & 0b11111101);
      PORTB |= (1<<PORTB0);
    }
    
    //PORTB &= (0<<PORTB0);
    */
      
    //read thermistor voltage
    //set AREF to VCC in ADMUX
    ADMUX &= ~(1<<REFS2) & ~(1<<REFS1) & ~(1<<REFS0);
    //set channel to ADC3/PB3 (MUX[0011])
    ADMUX = (ADMUX & 0xF0)|0b11;
    //discard first ADC reading
    //start single conversion
    ADCSRA |= (1<<ADSC);
    //wait for conversion
    while(ADCSRA & (1<<ADSC));
    junk = ADC;
    //use second ADC reading
    //start single conversion
    ADCSRA |= (1<<ADSC);
    //wait for conversion
    while(ADCSRA & (1<<ADSC));
    //set ADC reading to temperature
    temperature = ADC;

    //if thermistor ADC reading is above 512, then put PB2 high (red LED on, for hot? resistance goes up with temp?)
    //if thermistor ADC reading is 512 or below, then put PB2 low (blue LED on, for cold?)

    //PB2 is red- hot, so adc reading should be low
    //PB4 is white- medium hot
    //PB0 is yellow- medium
    //PB1 is green- cool
    //and blue is on by default

    if (temperature > 700) {
      PORTB |= (1<<PORTB2)|(1<<PORTB4)|(1<<PORTB0)|(1<<PORTB1);
    }
    
    if (temperature > 600) {
      PORTB &= ~(1<<PORTB1);
      PORTB |= (1<<PORTB2);
      PORTB |= (1<<PORTB4);
      PORTB |= (1<<PORTB0);
    }
    else if (temperature > 575) {
      PORTB &= ~(1<<PORTB0);
      PORTB &= ~(1<<PORTB1);
      PORTB |= (1<<PORTB2);
      PORTB |= (1<<PORTB4);
    }
    else if (temperature > 550) {
      PORTB &= ~(1<<PORTB4);
      PORTB &= ~(1<<PORTB0);
      PORTB &= ~(1<<PORTB1);
      PORTB |= (1<<PORTB2);
    }
    else if (temperature > 525) {
      PORTB &= ~(1<<PORTB2);
      PORTB &= ~(1<<PORTB4);
      PORTB &= ~(1<<PORTB0);
      PORTB &= ~(1<<PORTB1);

    }

    //PORTB = (PORTB & 0b11111101);
  }	

}






